SystemOrganization addCategory: #GODProcessors!

Object subclass: #PCSProcessor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GODProcessors'!

!PCSProcessor commentStamp: 'FCB 10/2/2014 16:24' prior: 0!
Superclass of package GODProcessors!

!PCSProcessor methodsFor: 'counting' stamp: 'TD 10/28/2014 09:38'!
countIn: aString
	"return a Dictionary with the number of ocurrences of each word in aString"
	|aCollection  aSet aDictionary|
	aCollection := Array new.
	aSet := Set new.
	aDictionary := Dictionary new. 

	aCollection := aString  subStrings. 
	aSet := aCollection asSet.
	aSet do: [ :aSubString | aDictionary add: (Association key: aSubString value: (aCollection occurrencesOf: aSubString)).].

	 ^aDictionary! !

!PCSProcessor methodsFor: 'counting' stamp: 'TD 10/28/2014 09:39'!
countIn: aString ocurrencesOf: aWord
	"return the number of ocurrences of aWord in aString"
	|aCollection n|
	aCollection := Array new.

	aCollection := aString  subStrings. 
	
	n := aCollection occurrencesOf: aWord.
	^n.! !

PCSProcessor subclass: #PCSStatisticsCalculator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GODProcessors'!

!PCSStatisticsCalculator methodsFor: 'averages_and_variances' stamp: 'TD 9/27/2014 14:30'!
average: aCollection 
	"compute the average of the collection of real numbers"
	^aCollection average.! !

!PCSStatisticsCalculator methodsFor: 'averages_and_variances' stamp: 'TD 10/7/2014 19:38'!
average: aCollection key: aKey
	"compute the average of key in the collection"
	| aNumberCollection |
	
	aNumberCollection := Bag new: aCollection size.
	
	aCollection do: [ :each | aNumberCollection add: (aKey value: each) ].
	
	^self average: aNumberCollection.! !

!PCSStatisticsCalculator methodsFor: 'tagging' stamp: 'TD 10/28/2014 09:52'!
generateTags: aGODData
    "add tags to a GodData object
	this method has been deprecated
	The feature has been replaced by the class Tagger that uses Information Retrieval technics
	
	To tag all element of a collection, you should do as following
		pcsTagger = PCSTagger new.
		pcsTagger.tagCollection: aGODDataCollection.
	
	To tag an element, you should do as following:
		pcsTagger = PCSTagger new.
		pcsTagger.training: aGODDataCollection.
		pcsTagger.addTagsTo: aGODData.
    "

    |aString aCollection aDictionary|
    
    aDictionary := Dictionary new.
    aCollection := OrderedCollection new.
    aString := String new.
    aString := aGODData content.
    aDictionary := self countIn: aString.
    aCollection := (Dictionary associations asSortedCollection: [:x :y | x value > y value]) 
            collect: [:association | association key].
    
    aGODData tags add: (aCollection at: 1).
    aGODData tags add: (aCollection at: 2).
    aGODData tags add: (aCollection at: 3).! !

!PCSStatisticsCalculator methodsFor: 'initializing' stamp: 'TD 9/27/2014 13:35'!
initialize
	! !

!PCSStatisticsCalculator methodsFor: 'averages_and_variances' stamp: 'TD 10/20/2014 14:15'!
median: aCollection 
	"compute the median of the collection of Number"
	^aCollection median.! !

!PCSStatisticsCalculator methodsFor: 'averages_and_variances' stamp: 'TD 10/20/2014 14:15'!
median: aCollection key: aKey
	"compute the median of this key(k) in the collection(c)"
	|aNumberCollection|
	aNumberCollection := Bag new: aCollection size.
	
	aCollection do: [ :each | aNumberCollection add: (aKey value: each) ].
	
	^self median: aNumberCollection.

	! !

!PCSStatisticsCalculator methodsFor: 'averages_and_variances' stamp: 'TD 10/20/2014 14:31'!
std: aCollection 
	"compute the standard deviation of the collection"
	
	^(self var: aCollection) sqrt.! !

!PCSStatisticsCalculator methodsFor: 'averages_and_variances' stamp: 'TD 10/20/2014 14:39'!
std: aCollection key: aKey
	"compute the standard deviation of key in the collection"
	|aNumberCollection|
	aNumberCollection := Bag new: aCollection size.
	
	aCollection do: [ :each | aNumberCollection add: (aKey value: each) ].
	
	^self std: aNumberCollection.! !

!PCSStatisticsCalculator methodsFor: 'averages_and_variances' stamp: 'TD 10/20/2014 14:42'!
var: aCollection 
	"compute the variance of the collection"
	|average sum|
	
	average := self average: aCollection.
	sum := 0.
	aCollection do: [:aNumber| sum := sum + ((aNumber - average) raisedTo: 2 ) ].
	
	^sum / aCollection size.! !

!PCSStatisticsCalculator methodsFor: 'averages_and_variances' stamp: 'TD 10/20/2014 14:30'!
var: aCollection key: aKey
	"compute the variance of the key in the collection"
	|aNumberCollection|
	aNumberCollection := Bag new: aCollection size.
	
	aCollection do: [ :each | aNumberCollection add: (aKey value: each) ].
	
	^self var: aNumberCollection.! !

PCSProcessor subclass: #PCSTagger
	instanceVariableNames: 'dictIdf maxTf minTf minRelevance'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GODProcessors'!

!PCSTagger methodsFor: 'as yet unclassified' stamp: 'TD 10/28/2014 10:41'!
addTagsTo: aGodData
 
	|tags|

	" Get most relevants tokens in aGodData and add it as tags of aGodData "
	
	tags := self getMoreRelevantsOf: aGodData content.
	aGodData tags: tags.! !

!PCSTagger methodsFor: 'as yet unclassified' stamp: 'TD 10/28/2014 10:18'!
countIn: aBag
	"return a Dictionary with the number of ocurrences of each word in aString"
	|  aSet aDictionary|

	aSet := Set new.
	aDictionary := Dictionary new. 

	aSet := aBag asSet.
	aSet do: [ :aToken | 
		aDictionary add: (Association key: aToken value: (aBag occurrencesOf: aToken))
	].

	 ^aDictionary! !

!PCSTagger methodsFor: 'as yet unclassified' stamp: 'TD 10/28/2014 10:43'!
createDictIdf: aStringCollection
  	|numDocuments dictDf aBag|
  	numDocuments := aStringCollection size.
  	dictDf := Dictionary new.
	
  	"gera o dicionario de frequencias de cada documento "
  	aStringCollection do: [ :aElement |
		aBag := self  preprocess: aElement.
		aBag asSet do: [ :token |
      		dictDf at: token put: ((dictIdf at: token) + 1)
		]
    	].

  	"converte dict_df into a Inverse Document Frequency dictionary"
  	dictIdf := Dictionary new.
  	dictDf keysAndValuesDo: [ :token :freq |
    		dictIdf at: token put: ((freq / numDocuments) log)
  	].! !

!PCSTagger methodsFor: 'as yet unclassified' stamp: 'TD 10/28/2014 10:25'!
createDictTf: aString
  	|aBag aDictTf|
	
  	" convert aString to an Bag of tokens"
  	aBag := self preprocess: aString.

  	" calculates number of ocourrences of each token"
  	aDictTf := self countIn: aBag.

  	"TODO:
		 remove from aDictTf token with frequence out of the interval [min_tf, max_tf]
  	"

   	^aDictTf! !

!PCSTagger methodsFor: 'as yet unclassified' stamp: 'TD 10/28/2014 10:40'!
getMoreRelevantsOf: aString
 
	|dictTf tfIdfDict tfidf|

	"TODO check if dictIdf is not empty
	in this case raise error
		message: dictIdf is Empty, make shure of call 'training' before call this method
	"
  	dictTf :=  self createDictTf: aString.
  	"calcula o tfidf de cada termo de aDict"
  	tfIdfDict := Dictionary new.
  	dictTf keysAndValuesDo: [ :token :tf |
    		tfidf := self tfIdf: token withFrequence: tf.
   		 (tfidf > minRelevance)
			ifTrue: [
      			tfIdfDict at: token put: tf
    			]
  	].
  	^(tfIdfDict keys).! !

!PCSTagger methodsFor: 'as yet unclassified' stamp: 'TD 10/28/2014 10:28'!
preprocess: aString
  | aBag |
  "this method realizes comom preprocess methods over the String
	1- tokenizes the String 
    - may remove common words
    - capitalize tokens
    - may do stemming and lemmatization
	anArray := self tokenizer: aS. 
  "
	aBag := self tokenizer: aString. 
	
	
	^aBag! !

!PCSTagger methodsFor: 'as yet unclassified' stamp: 'TD 10/28/2014 10:55'!
tagCollection: aGODDataCollection

  self training: aGODDataCollection.
  aGODDataCollection do: [ :element |
    self addTagsTo: element
  ].! !

!PCSTagger methodsFor: 'as yet unclassified' stamp: 'TD 10/28/2014 09:56'!
tfIdf: aTerm withFrequence: aFrequence
  ^(aFrequence * dictIdf at: aTerm).! !

!PCSTagger methodsFor: 'as yet unclassified' stamp: 'TD 10/28/2014 10:28'!
tokenizer: aString
  	|aBag|
	"this method split aString and return a Bag of tokens"
	
	"we decide to use a Bag, once the order of the tokens doesn't matter"
	aBag := (aString subStrings) asBag.
	^aBag.! !

!PCSTagger methodsFor: 'as yet unclassified' stamp: 'TD 10/28/2014 10:51'!
training: aGODDataCollection
	|aStringCollection|
	
  	"it extacts the aGODDataCollection's contents"
	aStringCollection := Bag new.
  	aGODDataCollection do: [ :aElement |
		aStringCollection add: aElement content.
    	].
  	"it trains the algorithm with the given aGODDataCollection contents"
	self createDictIdf: aStringCollection.! !
